/*
 * aufgabe5.c
 *
 *  Created on: 03.11.2012
 *      Author: johann
 */

#include <stdio.h>
#include <stdlib.h>

int main()
{
	setvbuf(stdout, NULL, _IONBF, 0);    /*    Die Standard-Ausgabe wird nicht gepuffert      */
	int i, N, N_innerhalb = 0;
	long seed;
	double x, y, a = 4.0,b = 2.0 , A_gesamt, A_parabel, A_exakt = 16.0/3.0, err;


	printf("Anzahl der Punkte: ");
	scanf("%d", &N);

	printf("Seed-Wert: ");
	scanf("%ld", &seed);
	srand48(seed);


	A_gesamt = a*b;		// Referenzflaeche, welche die gesuchte Flaeche enthaelt
	// (Rechteck mit Seitenlaengen a und b)
	printf("A_exakt = %.2lf\n", A_exakt);
	printf("A_gesamt = %.2lf\n", A_gesamt);

	for (i=0; i<N; i++)           // Schleife ueber Punkte
	{
		// Zufaelligen Punkt (x,y) erzeugen
		// Skalierung auf Rechteck mit den Seitenlaengen a und b; von unterer linken Ecke = (1,0) aus
		x = 1+a*drand48();
		y = b*drand48();
		// Skalierung auf Rechteck mit den Seitenlaengen a und b um Mittelpunkt = (3,1)
		//x = 3+a*(drand48()-0.5);
		//y = 1+b*(drand48()-0.5);
		printf("(x,y)=(%lf,%lf)\n",x,y);
		if ( y<2-0.5*(x-3)*(x-3)  )// Innerhalb oder ausserhalb?
			N_innerhalb++;
	}
	//printf("N_innerhalb=%d\n",N_innerhalb);
	A_parabel = (double)N_innerhalb / N * A_gesamt;	// Approximierte Flaeche der Ellipse

	err = A_exakt - A_parabel;

	if (err<0)
		err=-err;
	err  =err/A_parabel*100;

	printf("Die Flaeche betraegt etwa %lf\n", A_parabel);
	printf("Der Fehler betraegt err = %lf %%)\n", err);

	return 0;
}
